package data.scripts;

import com.fs.starfarer.api.graphics.SpriteAPI;
import java.awt.Color;
import org.lwjgl.util.vector.Vector2f;

public class fx_Particle {

    public float totalTime;
    public float endTime;
    public float fadeTime;
    public Vector2f size;

    public Vector2f position;
    public Vector2f velocity;
    public float angle;

    public float growth;

    public boolean isAdditive;
    public boolean isBlended;
    public Color curColor;
    public Color startRGB;
    public Color endRGB;

    public final SpriteAPI sprite;

	public final int textureID;

    public boolean isFading;
    public boolean killMe;

    public fx_Particle(SpriteAPI spr, float eTime, float fTime, Vector2f iSize, Vector2f pos, Vector2f vel, float ang, boolean isAdd, boolean isBlend, Color sRGB, Color eRGB, float grow) {
		sprite = spr;
		textureID = spr.getTextureId();
		//Timer controls
		totalTime = eTime;
		endTime = eTime;
		fadeTime = fTime;
		size = iSize;
		//Physics variables
		position = pos;
		velocity = vel;
		angle = ang;

		//growth or shrinkage
		growth = grow;

		//Color variables
		isAdditive = isAdd;
		isBlended = isBlend;
		curColor = sRGB;
		startRGB = sRGB;
		endRGB = eRGB;

		//Control states
		killMe = false;
		isFading = false;
    }

    public boolean isFading() {
		return isFading;
    }

    public void fade() {
		isFading = true;
    }

    public void kill() {
		killMe = true;
    }

    public boolean isDead() {
		return killMe;
    }

    public float timeLeft() {
		return endTime;
    }

    public void timerChange(float time) {
		endTime = time;
    }
}
