package data.scripts;

import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.campaign.FactionAPI;
import com.fs.starfarer.api.campaign.MissionBoardAPI;
import com.fs.starfarer.api.campaign.SectorEntityToken;
import com.fs.starfarer.api.campaign.MissionBoardAPI.MissionAvailabilityAPI;
import com.fs.starfarer.api.campaign.RepLevel;
import com.fs.starfarer.api.campaign.events.CampaignEventManagerAPI;
import com.fs.starfarer.api.campaign.events.CampaignEventPlugin;
import com.fs.starfarer.api.impl.campaign.missions.BaseCampaignMission;
import com.fs.starfarer.api.impl.campaign.missions.FactionCommissionMissionEvent;
import com.fs.starfarer.api.util.Misc;

public class FactionCommissionMissionAnnul extends BaseCampaignMission {
	private FactionAPI faction;
	
	public FactionCommissionMissionAnnul(String factionId) {
		this.faction = Global.getSector().getFaction(factionId);	
		
		CampaignEventManagerAPI eventManager = Global.getSector().getEventManager();
		event = eventManager.primeEvent(null, "faction_commission_annul", this);		
	}
	
	@Override
	public void advance(float amount) {
		super.advance(amount);
	}
	
	public FactionAPI getFaction() {
		return faction;
	}
	
	@Override
	public String getFactionId() {
		return faction.getId();
	}

	@Override
	public String getPostingStage() {
		return super.getPostingStage();
	}

	@Override
	public String getName() {
		return Misc.ucFirst(faction.getDisplayName()) + " Commission Renounce";
	}

	@Override
	public void playerAccept(SectorEntityToken entity) {
		super.playerAccept(entity);
		
		//Remove this after accepted.
		MissionBoardAPI board = Global.getSector().getMissionBoard();
		for (MissionAvailabilityAPI ma : board.getMissionsCopy()) {
			if (ma.getMission() instanceof FactionCommissionMissionAnnul) {
				FactionCommissionMissionAnnul fcm = (FactionCommissionMissionAnnul) ma.getMission();
				board.removeMission(fcm, true);
			}
		}	
		
		FactionAPI commFaction = Misc.getCommissionFaction();
		float rep = commFaction.getRelationship("player");
		commFaction.setRelationship("player", RepLevel.SUSPICIOUS);
		FactionCommissionMissionEvent tEvent = Misc.getCommissionEvent();
		if(tEvent != null){
			tEvent.advance(1f);
			tEvent.cleanup();
		}
		commFaction.setRelationship("player", rep);
	}
	
	@Override
	public boolean canPlayerAccept() {
		return true;
	}

	@Override
	public CampaignEventPlugin getPrimedEvent() {
		return event;
	}
}






