package data.scripts;

import java.awt.Color;
import java.util.List;
import java.util.Map;

import com.fs.starfarer.api.campaign.InteractionDialogAPI;
import com.fs.starfarer.api.campaign.events.CampaignEventTarget;
import com.fs.starfarer.api.campaign.rules.MemoryAPI;
import com.fs.starfarer.api.impl.campaign.events.BaseEventPlugin;
import com.fs.starfarer.api.util.Misc;
import com.fs.starfarer.api.util.Misc.Token;
import java.util.ArrayList;

public class FactionCommissionMissionAnnulEvent extends BaseEventPlugin {
	private FactionCommissionMissionAnnul mission = null;
	
	@Override
	public void init(String type, CampaignEventTarget eventTarget) {
		super.init(type, eventTarget, false);
	}
	
	protected Object readResolve() {
		return this;
	}
	
	@Override
	public void setParam(Object param) {
		mission = (FactionCommissionMissionAnnul) param;
		faction = mission.getFaction();
		getEventTarget().getEntity().setFaction(mission.getFaction().getId());		
	}

	@Override
	public void startEvent() {
		super.startEvent(true);		
	}
	
	@Override
	public void advance(float amount) {
	}

	@Override
	public boolean callEvent(String ruleId, final InteractionDialogAPI dialog, List<Token> params, Map<String, MemoryAPI> memoryMap) {	
		return true;
	}
	
	@Override
	public Map<String, String> getTokenReplacements() {		
		Map<String, String> map = super.getTokenReplacements();
		map.put("$sender", faction.getDisplayName());
		addFactionNameTokens(map, "other", faction);
		return map;
	}

	@Override
	public String[] getHighlights(String stageId) {		
		List<String> result = new ArrayList<>();
		addTokensToList(result, "");
		return result.toArray(new String[0]);
	}
	
	@Override
	public Color[] getHighlightColors(String stageId) {
		return super.getHighlightColors(stageId);
	}

	@Override
	public boolean isDone() {
		return true;
	}

	@Override
	public String getEventName() {
		return Misc.ucFirst(faction.getDisplayName()) + " Commission - annulled";
	}

	@Override
	public CampaignEventCategory getEventCategory() {
		return CampaignEventCategory.MISSION;
	}

	@Override
	public String getEventIcon() {
		return faction.getCrest();
	}
}



