package data.scripts;

import com.fs.starfarer.api.combat.CombatEngineAPI;
import com.fs.starfarer.api.combat.CombatEntityAPI;
import com.fs.starfarer.api.combat.DamageType;
import com.fs.starfarer.api.combat.DamagingProjectileAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.WeaponAPI;
import org.lazywizard.lazylib.VectorUtils;
import org.lwjgl.util.vector.Vector2f;

public class EZ_Damage
{
	private static final Vector2f NO_VEC = new Vector2f(0f,0f);
	public static void DamageThis(ShipAPI owner, WeaponAPI weapon, CombatEntityAPI target, CombatEngineAPI engine, DamageType damageType, Vector2f point, float damage, float emp){
		float angle = VectorUtils.getAngle(point, target.getLocation());
		switch (damageType) {
			case ENERGY:
				{
					DamagingProjectileAPI proj = (DamagingProjectileAPI) engine.spawnProjectile(owner, weapon, "ez_damage_e", point, angle, NO_VEC);
					proj.setDamageAmount(damage);
					if(emp > 0){
						for(int i = 0; i <= (int)emp / 50; i+=50){
							engine.spawnProjectile(owner, weapon, "ez_emp", point, angle, NO_VEC);
						}
					}
					break;
				}
			case FRAGMENTATION:
				{
					DamagingProjectileAPI proj = (DamagingProjectileAPI) engine.spawnProjectile(owner, weapon, "ez_damage_f", point, angle, NO_VEC);
					proj.setDamageAmount(damage);
					if(emp > 0){
						for(int i = 0; i <= (int)emp / 50; i+=50){
							engine.spawnProjectile(owner, weapon, "ez_emp", point, angle, NO_VEC);
						}
					}
					break;
				}
			case HIGH_EXPLOSIVE:
				{
					DamagingProjectileAPI proj = (DamagingProjectileAPI) engine.spawnProjectile(owner, weapon, "ez_damage_h", point, angle, NO_VEC);
					proj.setDamageAmount(damage);
					if(emp > 0){
						for(int i = 0; i <= (int)emp / 50; i+=50){
							engine.spawnProjectile(owner, weapon, "ez_emp", point, angle, NO_VEC);
						}
					}
					break;
				}	
			case KINETIC:
				{
					DamagingProjectileAPI proj = (DamagingProjectileAPI) engine.spawnProjectile(owner, weapon, "ez_damage_k", point, angle, NO_VEC);
					proj.setDamageAmount(damage);
					if(emp > 0){
						for(int i = 0; i <= (int)emp / 50; i+=50){
							engine.spawnProjectile(owner, weapon, "ez_emp", point, angle, NO_VEC);
						}
					}
					break;
				}
			default:
				//Do nothing at all
				break;
		}
	}
}
