package data.hullmods;

import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShieldAPI.ShieldType;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;
import com.fs.starfarer.api.impl.campaign.ids.Stats;

public class FormShield extends BaseHullMod {
	public static final float CORONA_EFFECT_REDUCTION = -1f;
	
	@Override
	public void applyEffectsBeforeShipCreation(HullSize hullSize, MutableShipStatsAPI stats, String id) {
		stats.getDynamic().getStat(Stats.CORONA_EFFECT_MULT).modifyFlatAfterMult(id, CORONA_EFFECT_REDUCTION);
	}

	@Override
	public String getDescriptionParam(int index, HullSize hullSize) {
		return null;
	}

	@Override
	public boolean isApplicableToShip(ShipAPI ship) {
		return ship != null && (ship.getHullSpec().getDefenseType() == ShieldType.NONE || ship.getVariant().getHullMods().contains("shields_shieldremoved"));
	}
	
	@Override
	public String getUnapplicableReason(ShipAPI ship) {
		return "Ship already has shields";
	}
}
