package data.scripts.weapons;

import org.lwjgl.util.vector.Vector2f;
import com.fs.starfarer.api.combat.CombatEngineAPI;
import com.fs.starfarer.api.combat.CombatEntityAPI;
import com.fs.starfarer.api.combat.WeaponAPI;
import com.fs.starfarer.api.combat.DamageType;
import com.fs.starfarer.api.combat.DamagingProjectileAPI;
import com.fs.starfarer.api.combat.OnHitEffectPlugin;
import com.fs.starfarer.api.combat.ShipAPI;
import data.scripts.EZ_Damage;
import data.scripts.weapons.helperUtils.VacuumWeaponUtils;

import org.lazywizard.lazylib.MathUtils;

public class PlasmaOnHitEffect implements OnHitEffectPlugin {
	private final float REPEATS = 20;
	
    @Override
    public void onHit(DamagingProjectileAPI projectile, CombatEntityAPI target,Vector2f point, boolean shieldHit, CombatEngineAPI engine) {
        if (target instanceof ShipAPI) 
        {
            ShipAPI ship = (ShipAPI) target;
            float emp = projectile.getEmpAmount();
            float dam = projectile.getDamageAmount();
            WeaponAPI weapon = projectile.getWeapon();
            if(weapon == null) return;
            DamageType damType = weapon.getDamageType();
            
            //int heatMe = 20;
            //Damage is now reduced, now that we have the "coverage"
            dam  *= 0.5f;
            emp *= 0.5f;
			dam /= REPEATS;
			emp /= REPEATS;
			
			//Weapons do 20 random strikes per hit, at 50% damage divided by 20 (or 2.5 damage per 100 raw).
            for(int i = 0; i < (int)REPEATS; i++)
            {
                Vector2f offset = MathUtils.getRandomPointInCircle(ship.getLocation(),ship.getCollisionRadius());
				EZ_Damage.DamageThis(projectile.getSource(), weapon, target, engine, damType, offset, dam, emp);
            }				   
        }
    }
}
