package data.shipsystems.scripts;

import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.impl.combat.BaseShipSystemScript;

public class EXP_EnergyRangeStats extends BaseShipSystemScript {

	public static final float RANGE_BONUS = 100f;
	
	@Override
	public void apply(MutableShipStatsAPI stats, String id, State state, float effectLevel) {
		float bonusPercent = RANGE_BONUS * effectLevel;
		stats.getEnergyWeaponRangeBonus().modifyPercent(id, bonusPercent);
		stats.getBeamWeaponRangeBonus().modifyPercent(id, bonusPercent);
	}
	
	@Override
	public void unapply(MutableShipStatsAPI stats, String id) {
		stats.getEnergyWeaponRangeBonus().unmodify(id);
		stats.getBeamWeaponRangeBonus().unmodify(id);
	}
	
	@Override
	public StatusData getStatusData(int index, State state, float effectLevel) {
		float bonusPercent = RANGE_BONUS * effectLevel;
		switch (index) {
			case 0:
				return new StatusData("+" + (int) bonusPercent + "% energy / beam weapon range" , false);
			case 1:
				return null;
			case 2:
				return null;
			default:
				break;
		}
		return null;
	}
}
