package data.scripts.plugins;

import java.util.List;

import org.lwjgl.util.vector.Vector2f;

import com.fs.starfarer.api.combat.CombatEngineAPI;
import com.fs.starfarer.api.combat.EveryFrameCombatPlugin;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.CollisionClass;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ViewportAPI;


public class ShipPhysics implements EveryFrameCombatPlugin {

	private CombatEngineAPI engine;
    private float height;
    private float width;

        @Override
	public void init(CombatEngineAPI engine) {
		this.engine = engine;
		this.height = engine.getMapHeight() / 2f;
		this.width = engine.getMapWidth() / 2f;
	}

	@Override
	public void advance(float amount, List events) 
	{
			if (engine == null) return;
            if (engine.isPaused()) return;

            //Gets all ships;
            List<ShipAPI> ships = engine.getShips();
            for (ShipAPI ship : ships) {
                
                MutableShipStatsAPI stats = ship.getMutableStats();
                
                if(!ship.isRetreating() && !ship.isLanding()&& !ship.isShuttlePod() && !ship.getTravelDrive().isOn() && !ship.getTravelDrive().isActive()){
                    Vector2f pos = ship.getLocation();
                    float posX = pos.getX();
                    float posY = pos.getY();

                    if(posX > 0 && posX >= width){
                        ship.getLocation().x = width;
                    } else if (posX < 0 && posX <= -width){
                        ship.getLocation().x = -width;
                    }

                    if(posY > 0 && posY >= height){
                        ship.getLocation().y = height;
                    }else if (posY < 0 && posY <= -height){
                        ship.getLocation().y = -height;
                    }                
                }
                if(ship.isHulk())
                {
                    //Makes Hulks slow down over time, instead of drifting endlessly.
                    Vector2f hulkVec = ship.getVelocity();
                    hulkVec.x *= 0.997f;
                    hulkVec.y *= 0.997f;
                    ship.setCollisionClass(CollisionClass.SHIP);
                }
            }
	}

	@Override
	public void renderInWorldCoords(ViewportAPI vapi) {
	}

	@Override
	public void renderInUICoords(ViewportAPI vapi) {
	}
}