package data.scripts.weapons.missileai;

import com.fs.starfarer.api.combat.CombatEntityAPI;
import com.fs.starfarer.api.combat.MissileAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import org.lazywizard.lazylib.MathUtils;
import org.lazywizard.lazylib.VectorUtils;
import org.lwjgl.util.vector.Vector2f;


public class SteerMissileStandard {
	public static boolean[] SteerMissileStandard(MissileAPI missile, CombatEntityAPI target, boolean heatSeeker){
			boolean turnRight = false;
			boolean turnLeft = false;
			boolean strafeLeft = false;
			boolean strafeRight = false;
			boolean isAccelerating = false;
			boolean canStrafe = true;
			
            Vector2f MVel = missile.getVelocity();
            Vector2f MLoc = missile.getLocation();
            Vector2f TVel = target.getVelocity();
            Vector2f TLoc = target.getLocation();
            float MFace = missile.getFacing();
			
			if(heatSeeker && target instanceof ShipAPI){
				canStrafe = false;
				if(MathUtils.getDistanceSquared(TLoc, MLoc) > ((target.getCollisionRadius() + 300f) * (target.getCollisionRadius() + 300f))){				
					//Get the angle from the target to the missile
					float AngleToMissile = VectorUtils.getAngle(MLoc, TLoc);
					//Use the target's facing to find out where forwards is
					float TFace = target.getFacing();
					//Now get the angle we need to determine the missile's correct heading
					float angleToMissileTarget = getAngleDifference(TFace, AngleToMissile); 
					float absAngToMTarg = Math.abs(angleToMissileTarget);

					if(absAngToMTarg > 170f){
						Vector2f pointA = MathUtils.getPointOnCircumference(TLoc, target.getCollisionRadius() + 800f, MathUtils.clampAngle(TFace + 90f));
						Vector2f pointB = MathUtils.getPointOnCircumference(TLoc, target.getCollisionRadius() + 800f, MathUtils.clampAngle(TFace - 90f));
						Vector2f pointC = MathUtils.getPointOnCircumference(TLoc, target.getCollisionRadius() + 800f, MathUtils.clampAngle(TFace + 140f));
						Vector2f pointD = MathUtils.getPointOnCircumference(TLoc, target.getCollisionRadius() + 800f, MathUtils.clampAngle(TFace - 140f));
						float distA = MathUtils.getDistanceSquared(MLoc, pointA);
						float distB = MathUtils.getDistanceSquared(MLoc, pointB);
						float distC = MathUtils.getDistanceSquared(MLoc, pointC);
						float distD = MathUtils.getDistanceSquared(MLoc, pointD);
						if(distA < distB && distA < distC && distA < distD){
							TLoc = pointA;
						}
						if(distB < distA && distB < distC && distB < distD){
							TLoc = pointB;
						}		
						if(distC < distB && distC < distA && distC < distD){
							TLoc = pointC;
						}
						if(distD < distB && distD < distA && distD < distC){
							TLoc = pointD;
						}						
					}
				}
			}

            //Testing InterceptPoint, tests for slow-moving things now
            Vector2f TLead;
            if(TVel.length() < 100f){
                TLead = TLoc;
            } else {
                float TCol = target.getCollisionRadius();
                Vector2f TVelShort = VectorDirection(TVel, TCol);
                TLead = new Vector2f(TLoc.getX() + TVelShort.getX(),TLoc.getY() + TVelShort.getY());
            }

            //Main aiming logic
			//Get the angle to the correct aim point
            float AngleToEnemy = VectorUtils.getAngle(MLoc, TLead);
			//Is our angular difference between where the missile faces and the correct enemy positive or negative?
            float angleToTarget = getAngleDifference(MFace, AngleToEnemy);         
			//Gets the absolute value of the angle, so we know how far off we are
            float AbsAngD = Math.abs(angleToTarget);

            //////////////////////////////////////////////////////////////////////////////////////////////

            if (AbsAngD < 5)
            {
                //course correct for missile velocity vector (some bugs when severely off target)
                float MFlightAng = VectorUtils.getAngle(new Vector2f(0, 0), MVel);
                float MFlightCC = getAngleDifference(MFace, MFlightAng);
                if (Math.abs(MFlightCC)>20)
                {
                    if(MFlightCC < 0){
                        strafeLeft = true;
						canStrafe = false;
                    } else {
                        strafeRight = true;
						canStrafe = false;
                    }
                }
            }
            
            //point towards target
            if (AbsAngD >= 0.5)
            {
                if(angleToTarget > 0){
                    turnLeft = true;
                }else{
                    turnRight = true;
                }
            }
            
            //Damp angular velocity if we're getting close to the target angle
            if(AbsAngD < Math.abs(missile.getAngularVelocity())){
                if(angleToTarget > 0){
                    missile.setAngularVelocity(AbsAngD); 
                }else if (angleToTarget < 0){
                    missile.setAngularVelocity(-AbsAngD);
                }                
            }

            //acceleration code
            if (AbsAngD < 90)
            {
                isAccelerating = true;
            }	
			
        boolean[] commandList = new boolean[6];
        commandList[0] = turnLeft;
        commandList[1] = turnRight;
        commandList[2] = strafeLeft;
        commandList[3] = strafeRight;
        commandList[4] = isAccelerating;
		commandList[5] = canStrafe;
        return commandList;			
	}

    //Returns a new vector with original direction but new length
    private static Vector2f VectorDirection(Vector2f vec, float size)
    {
        float x = vec.getX();
        float y = vec.getY();

        float lenght =(float) Math.hypot(x, y);
        return new Vector2f(x*size/lenght, y*size/lenght);
    }           

    // Will be in next LazyLib version
    private static float getAngleDifference(float angle1, float angle2)
    {
        float distance = (angle2 - angle1) + 180f;
        distance = (distance / 360.0f);
        distance = ((distance - (float) Math.floor(distance)) * 360f) - 180f;
        return distance;
    }
}
