package data.shipsystems.scripts.ai;


import com.fs.starfarer.api.combat.CollisionClass;
import org.lwjgl.util.vector.Vector2f;

import com.fs.starfarer.api.combat.CombatEngineAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.ShipCommand;
import com.fs.starfarer.api.combat.ShipSystemAIScript;
import com.fs.starfarer.api.combat.ShipSystemAPI;
import com.fs.starfarer.api.combat.ShipwideAIFlags;
import com.fs.starfarer.api.util.IntervalUtil;
import org.lazywizard.lazylib.combat.AIUtils;

public class AlwaysOnAI implements ShipSystemAIScript {

    private ShipAPI ship;
    private CombatEngineAPI engine;
    private boolean shouldUseSystem = false;
    private final IntervalUtil tracker = new IntervalUtil(0.3f, 0.5f);

    @Override
    public void init(ShipAPI thisShip, ShipSystemAPI thisSystem, ShipwideAIFlags flags, CombatEngineAPI thisEngine) {
        ship = thisShip;
        engine = thisEngine;
    }

    @Override
    public void advance(float amount, Vector2f missileDangerDir, Vector2f collisionDangerDir, ShipAPI target)
    {
        if(engine == null) return;
        if(engine.isPaused()) return;
		if(ship.getCollisionClass().equals(CollisionClass.NONE)) return;

        tracker.advance(amount);
        if (tracker.intervalElapsed()){
			shouldUseSystem = AIUtils.canUseSystemThisFrame(ship);
			if(shouldUseSystem)	ship.useSystem();
        }
    }
}
