package data.scripts.weapons.helperUtils;

import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.combat.CombatEngineAPI;
import com.fs.starfarer.api.combat.CombatEntityAPI;
import com.fs.starfarer.api.combat.DamageType;
import com.fs.starfarer.api.combat.MissileAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.WeaponAPI;
import data.scripts.EZ_Damage;
import java.awt.geom.Line2D;
import java.util.ArrayList;
import java.util.List;
import org.lazywizard.lazylib.MathUtils;
import org.lwjgl.util.vector.Vector2f;


public class RebalWeaponUtils {    
    public static void rebalDamageThisEntity(Vector2f loc, CombatEntityAPI enemy, float damage, float emp, DamageType damageType, CombatEngineAPI engine, ShipAPI owner){
        Vector2f point;
        if(!(enemy instanceof ShipAPI)){
			point = enemy.getLocation();
			WeaponAPI theWeapon = null;
			for(WeaponAPI weapon : owner.getAllWeapons()){
				if(!weapon.isDecorative()){
					theWeapon = weapon;
				}
				break;
			}
			if(theWeapon != null){
				EZ_Damage.DamageThis(owner, theWeapon, enemy, engine, damageType, point, damage, emp);
			}
        } else {
			point = enemy.getLocation();
			WeaponAPI theWeapon = null;
			for(WeaponAPI weapon : owner.getAllWeapons()){
				if(!weapon.isDecorative()){
					theWeapon = weapon;
				}
				break;
			}
			if(theWeapon != null){
				EZ_Damage.DamageThis(owner, theWeapon, enemy, engine, damageType, point, damage, emp);
			}           
        }
    }    
    
    //Rewrite of LazyWizard's IsWithinArc
    public static boolean rebalIsWithinArc(CombatEntityAPI entity, WeaponAPI weapon, Vector2f weaponLoc, float weaponRange, float weaponArc, float weaponAngle)
    {
        // Check if weapon is in range
        if (!MathUtils.isWithinRange(entity, weaponLoc, weaponRange))
        {
            return false;
        }

        // Check if weapon is aimed at the target's center
        if (weapon.distanceFromArc(entity.getLocation()) == 0)
        {
            return true;
        }

        // Check if weapon is aimed at any part of the target
        Vector2f endArcLeft = MathUtils.getPointOnCircumference(weaponLoc, weaponRange,
                weaponAngle - weaponArc);
        Vector2f endArcRight = MathUtils.getPointOnCircumference(weaponLoc, weaponRange,
                weaponAngle + weaponArc);
        float radSquared = entity.getCollisionRadius() * entity.getCollisionRadius();
        Vector2f target = entity.getLocation();
        boolean partiallyInArc = (Line2D
                .ptSegDistSq(
                        weaponLoc.x,
                        weaponLoc.y,
                        endArcLeft.x,
                        endArcLeft.y,
                        target.x,
                        target.y) <= radSquared)
                || (Line2D
                .ptSegDistSq(
                        weaponLoc.x,
                        weaponLoc.y,
                        endArcRight.x,
                        endArcRight.y,
                        target.x,
                        target.y) <= radSquared);
        return partiallyInArc;
    }
    
    //Returns one of the nearest enemy MissileAPI objects to a point.  Not guaranteed to get the nearest object, for speed purposes.
    public static MissileAPI rebalGetNearestMissileNearPoint(int owner, Vector2f point, float range)
    {
        List<MissileAPI> enemies = new ArrayList<>();
        for (MissileAPI missile : Global.getCombatEngine().getMissiles())
        {
            if (    
                    missile.getOwner() != owner
                    && MathUtils.isWithinRange(missile,missile,range)
                )
            {
                enemies.add(missile);
            }
        }
        if(!enemies.isEmpty()){
            return enemies.get(0);
        } else {
            return null;
        }
    } 
    
}