package data.shipsystems.scripts;

import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.impl.combat.BaseShipSystemScript;

public class FortressShieldStats extends BaseShipSystemScript {
	@Override
	public void apply(MutableShipStatsAPI stats, String id, State state, float effectLevel) {
		stats.getShieldTurnRateMult().modifyMult(id, 1f);
		stats.getShieldUnfoldRateMult().modifyPercent(id, 2000);
		stats.getShieldDamageTakenMult().modifyMult(id, 1f - .9f * effectLevel);
		stats.getShieldUpkeepMult().modifyMult(id, 0f);
	}
	
	@Override
	public void unapply(MutableShipStatsAPI stats, String id) {
		stats.getShieldAbsorptionMult().unmodify(id);
		stats.getShieldArcBonus().unmodify(id);
		stats.getShieldDamageTakenMult().unmodify(id);
		stats.getShieldTurnRateMult().unmodify(id);
		stats.getShieldUnfoldRateMult().unmodify(id);
		stats.getShieldUpkeepMult().unmodify(id);
	}
	
	@Override
	public StatusData getStatusData(int index, State state, float effectLevel) {
		if (index == 0) {
			return new StatusData("shield absorbs 10x damage", false);
		}
		return null;
	}
}
