package data.hullmods;

import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;

public class DedicatedTargetingCore extends BaseHullMod {

	private final float RANGE_BONUS = 25f;
	private final float TURRET_TURN_NERF = 25f;
	
	@Override
	public String getDescriptionParam(int index, HullSize hullSize) {
		if (index == 0) return "" + (int)Math.round(RANGE_BONUS) + "%";
		if (index == 1) return "" + (int)Math.round(TURRET_TURN_NERF) + "%";
		return null;
	}
	
	@Override
	public void applyEffectsBeforeShipCreation(HullSize hullSize, MutableShipStatsAPI stats, String id) {
		stats.getBallisticWeaponRangeBonus().modifyMult(id, 1f + (RANGE_BONUS * 0.01f));
		stats.getEnergyWeaponRangeBonus().modifyMult(id, 1f + (RANGE_BONUS * 0.01f));
		stats.getWeaponTurnRateBonus().modifyMult(id, 1 - (TURRET_TURN_NERF * 0.01f));
	}

	@Override
	public boolean isApplicableToShip(ShipAPI ship) {
		return (
				ship.getMutableStats().getBeamWeaponRangeBonus().getMult() < 1.25f 
				&& ship.getMutableStats().getBallisticWeaponRangeBonus().getMult() < 1.25f
				&& ship.getMutableStats().getEnergyWeaponRangeBonus().getMult() < 1.25f
				&& ship.getMutableStats().getNonBeamPDWeaponRangeBonus().getMult() < 1.25f 
				&& ship.getMutableStats().getBeamPDWeaponRangeBonus().getMult() < 1.25f 
				);
	}
	
	
	@Override
	public String getUnapplicableReason(ShipAPI ship) {
		return "Incompatible with other Hull Mods that increase ranges.";
	}
	
}
