package data.hullmods;

import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;

public class EfficientEngines extends BaseHullMod {
	private static final int FUEL_EFFICIENCY = 50;
	private static final int STRENGTH_PENALTY = 50;
	private static final int PROFILE_PENALTY = 50;
	
	@Override
	public void applyEffectsBeforeShipCreation(HullSize hullSize, MutableShipStatsAPI stats, String id) {
		stats.getSensorProfile().modifyPercent(id, PROFILE_PENALTY);
		stats.getSensorStrength().modifyMult(id, 1f - STRENGTH_PENALTY * 0.01f);
		stats.getFuelUseMod().modifyMult(id, 1f - FUEL_EFFICIENCY * 0.01f);
	}
	
	@Override
	public String getDescriptionParam(int index, HullSize hullSize) {
		if (index == 0) return "" + FUEL_EFFICIENCY + "%";
		if (index == 1) return "" + STRENGTH_PENALTY + "%";
		if (index == 2) return "" + PROFILE_PENALTY + "%";
		return null;
	}

	@Override
	public boolean isApplicableToShip(ShipAPI ship) {
		return true;
	}
}
