package data.hullmods;

import java.util.HashMap;
import java.util.Map;

import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;

public class HeavyArmor extends BaseHullMod {

	public static final float MANEUVER_PENALTY = 20f;
	
	
	private static final Map<HullSize,Float> MAG = new HashMap();
	static {
		MAG.put(HullSize.FIGHTER, 100f);
		MAG.put(HullSize.FRIGATE, 100f);
		MAG.put(HullSize.DESTROYER, 85f);
		MAG.put(HullSize.CRUISER, 70f);
		MAG.put(HullSize.CAPITAL_SHIP, 60f);
	}
	
	@Override
	public void applyEffectsBeforeShipCreation(HullSize hullSize, MutableShipStatsAPI stats, String id) {
		float thisMag = MAG.get(hullSize);
		stats.getArmorBonus().modifyMult(id, 1f + thisMag * 0.01f);
		
		stats.getAcceleration().modifyMult(id, 1f - MANEUVER_PENALTY * 0.01f);
		stats.getDeceleration().modifyMult(id, 1f - MANEUVER_PENALTY * 0.01f);
		stats.getTurnAcceleration().modifyMult(id, 1f - MANEUVER_PENALTY * 0.01f);
		stats.getMaxTurnRate().modifyMult(id, 1f - MANEUVER_PENALTY * 0.01f);
	}
	
	@Override
	public String getDescriptionParam(int index, HullSize hullSize) {
		if (index == 0) return "" + Math.round(MAG.get(hullSize)) + "%";
		if (index == 1) return "" + (int) MANEUVER_PENALTY + "%";
		return null;
		//if (index == 0) return "" + ((Float) mag.get(hullSize)).intValue();
		//return null;
	}

	@Override
	public boolean isApplicableToShip(ShipAPI ship) {
		return true;
	}
}
