package data.hullmods;

import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;
import com.fs.starfarer.api.impl.campaign.ids.Stats;

public class IonShielding extends BaseHullMod {

	public static final float CORONA_EFFECT_REDUCTION = 0.25f;
	public static final float BEAM_DAMAGE_REDUCTION = 0.5f;
	public static final float EMP_DAMAGE_REDUCTION = 0.25f;
	
	@Override
	public void applyEffectsBeforeShipCreation(HullSize hullSize, MutableShipStatsAPI stats, String id) {
		stats.getEmpDamageTakenMult().modifyMult(id, EMP_DAMAGE_REDUCTION);
		stats.getBeamDamageTakenMult().modifyMult(id, BEAM_DAMAGE_REDUCTION);
		stats.getDynamic().getStat(Stats.CORONA_EFFECT_MULT).modifyMult(id, CORONA_EFFECT_REDUCTION);
	}
	
	@Override
	public String getDescriptionParam(int index, HullSize hullSize) {
		if (index == 0) return "" + Math.round((1f - EMP_DAMAGE_REDUCTION) * 100f) + "%";
		if (index == 1) return "" + Math.round((1f - BEAM_DAMAGE_REDUCTION) * 100f) + "%";
		if (index == 2) return "" + Math.round((1f - CORONA_EFFECT_REDUCTION) * 100f) + "%";
		return null;
	}


}
