package data.hullmods;

import java.util.HashMap;
import java.util.Map;

import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;
import com.fs.starfarer.api.impl.campaign.ids.Stats;

public class NavRelay extends BaseHullMod {

	private static final Map<HullSize,Float> MAG = new HashMap();
	static {
		MAG.put(HullSize.FIGHTER, 2f);
		MAG.put(HullSize.FRIGATE, 2f);
		MAG.put(HullSize.DESTROYER, 3f);
		MAG.put(HullSize.CRUISER, 4f);
		MAG.put(HullSize.CAPITAL_SHIP, 5f);
	}
	
	@Override
	public void applyEffectsBeforeShipCreation(HullSize hullSize, MutableShipStatsAPI stats, String id) {
		stats.getDynamic().getMod(Stats.COORDINATED_MANEUVERS_FLAT).modifyFlat(id, MAG.get(hullSize));
	}
	
	@Override
	public String getDescriptionParam(int index, HullSize hullSize) {
		if (index == 0) return "" + Math.round(MAG.get(hullSize)) + "%";
		return null;
	}
}




