package data.hullmods;

import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;

public class RapidVenting extends BaseHullMod {

	public static final float HARD_FLUX_DISSIPATION_PERCENT = 10f;
	public static final float VENT_RATE_BONUS = 75f;
	
	@Override
	public void applyEffectsBeforeShipCreation(HullSize hullSize, MutableShipStatsAPI stats, String id) {
		stats.getHardFluxDissipationFraction().modifyFlat(id, HARD_FLUX_DISSIPATION_PERCENT * 0.01f);
		stats.getVentRateMult().modifyPercent(id, VENT_RATE_BONUS);
	}
	
	@Override
	public String getDescriptionParam(int index, HullSize hullSize) {
		if (index == 0) return "" + Math.round(VENT_RATE_BONUS) + "%";
		if (index == 1) return "" + Math.round(HARD_FLUX_DISSIPATION_PERCENT) + "%";
		return null;
	}


}
