package data.hullmods;

import java.util.HashMap;
import java.util.Map;

import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;
import com.fs.starfarer.api.impl.campaign.ids.Stats;

public class RepairGantry extends BaseHullMod {
	
	private static final Map<HullSize,Float> MAG = new HashMap();
	static {
		MAG.put(HullSize.FIGHTER, 10f);
		MAG.put(HullSize.FRIGATE, 10f);
		MAG.put(HullSize.DESTROYER, 25f);
		MAG.put(HullSize.CRUISER, 30f);
		MAG.put(HullSize.CAPITAL_SHIP, 40f);
	}
	
	//private static final float SALVAGE_MODIFIER = .25f;
	
	@Override
	public void applyEffectsBeforeShipCreation(HullSize hullSize, MutableShipStatsAPI stats, String id) {
		stats.getDynamic().getMod(Stats.SALVAGE_VALUE_MULT_MOD).modifyFlat(id, MAG.get(hullSize) * 0.01f);
		stats.getDynamic().getMod(Stats.BATTLE_SALVAGE_VALUE_MULT_MOD).modifyFlat(id, MAG.get(hullSize) * 0.01f / 3f);
	}
	
	@Override
	public String getDescriptionParam(int index, HullSize hullSize) {	
		if (index == 0) return "" + Math.round(MAG.get(hullSize)) + "%";
		if (index == 1) return "" + Math.round(MAG.get(hullSize)/3f) + "%";
		return null;
	}


	@Override
	public void advanceInCombat(ShipAPI ship, float amount) {
		
	}
	
	
}









