package data.hullmods;

import java.util.HashMap;
import java.util.Map;

import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;
import com.fs.starfarer.api.impl.campaign.SurveyPluginImpl;
import com.fs.starfarer.api.impl.campaign.ids.Commodities;
import com.fs.starfarer.api.impl.campaign.ids.Stats;

public class SurveyingEquipment extends BaseHullMod {

	private static final Map<HullSize,Float> MAG = new HashMap();
	static {
		MAG.put(HullSize.FIGHTER, 1f);
		MAG.put(HullSize.FRIGATE, 5f);
		MAG.put(HullSize.DESTROYER, 10f);
		MAG.put(HullSize.CRUISER, 20f);
		MAG.put(HullSize.CAPITAL_SHIP, 30f);
	}
	
	@Override
	public void applyEffectsBeforeShipCreation(HullSize hullSize, MutableShipStatsAPI stats, String id) {
		stats.getDynamic().getMod(Stats.getSurveyCostReductionId(Commodities.HEAVY_MACHINERY)).modifyFlat(id, MAG.get(hullSize));
		stats.getDynamic().getMod(Stats.getSurveyCostReductionId(Commodities.SUPPLIES)).modifyFlat(id, MAG.get(hullSize));
	}
	
	@Override
	public String getDescriptionParam(int index, HullSize hullSize) {
		if (index == 0) return "" + Math.round(MAG.get(hullSize));
		if (index == 4) return "" + (int) SurveyPluginImpl.MIN_SUPPLIES_OR_MACHINERY;
		return null;
	}


}
