package data.scripts.skills;

import com.fs.starfarer.api.characters.FleetStatsSkillEffect;
import com.fs.starfarer.api.fleet.MutableFleetStatsAPI;
import com.fs.starfarer.api.impl.campaign.ids.Stats;

public class Surveying {
	
	public static final float LEVEL_1_HAZARD = 50f;
	public static final float LEVEL_2_HAZARD = 50f;
	public static final float LEVEL_3_HAZARD = 1000f;
	
	

	public static class Level1 implements FleetStatsSkillEffect {
		public void apply(MutableFleetStatsAPI stats, String id, float level) {
			stats.getDynamic().getMod(Stats.SURVEY_MAX_HAZARD).modifyFlat(id, LEVEL_1_HAZARD * 0.01f);
		}

		public void unapply(MutableFleetStatsAPI stats, String id) {
			stats.getDynamic().getMod(Stats.SURVEY_MAX_HAZARD).unmodify(id);
		}

		public String getEffectDescription(float level) {
			float max = 0f;
			max += LEVEL_1_HAZARD;
			return "Able to survey planets with a hazard rating of up to " + (int) max + "%";
		}

		public String getEffectPerLevelDescription() {
			return null;
		}

		public ScopeDescription getScopeDescription() {
			return ScopeDescription.FLEET;
		}
	}
	
	public static class Level2 implements FleetStatsSkillEffect {
		public void apply(MutableFleetStatsAPI stats, String id, float level) {
			stats.getDynamic().getMod(Stats.SURVEY_MAX_HAZARD).modifyFlat(id, LEVEL_2_HAZARD * 0.01f);
		}

		public void unapply(MutableFleetStatsAPI stats, String id) {
			stats.getDynamic().getMod(Stats.SURVEY_MAX_HAZARD).unmodify(id);
		}

		public String getEffectDescription(float level) {
			float max = 0f;
			max += LEVEL_1_HAZARD;
			max += LEVEL_2_HAZARD;
			return "Able to survey planets with a hazard rating of up to " + (int) max + "%";
		}
		
		public String getEffectPerLevelDescription() {
			return null;
		}
		
		public ScopeDescription getScopeDescription() {
			return ScopeDescription.FLEET;
		}
	}
	
	public static class Level3 implements FleetStatsSkillEffect {
		public void apply(MutableFleetStatsAPI stats, String id, float level) {
			stats.getDynamic().getMod(Stats.SURVEY_MAX_HAZARD).modifyFlat(id, LEVEL_3_HAZARD * 0.01f);
		}

		public void unapply(MutableFleetStatsAPI stats, String id) {
			stats.getDynamic().getMod(Stats.SURVEY_MAX_HAZARD).unmodify(id);
		}

		public String getEffectDescription(float level) {
			return "Able to survey planets with any hazard rating";
		}
		
		public String getEffectPerLevelDescription() {
			return null;
		}
		
		public ScopeDescription getScopeDescription() {
			return ScopeDescription.FLEET;
		}
	}
}



